#!/usr/bin/env python
# -*- mode: python; coding: koi8-r; -*-
#
# PySolFC Cardset Maker
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
### ToDo
### sorting of cards if names have no correcrt order, round edges with alpha channel,
### nicer symbols with option to save with or without




import sys, os
from glob import glob

from Tkinter import *
import tkFileDialog, tkMessageBox, tkColorChooser

from PIL import Image, ImageTk ###
##import Image, ImageTk
# for py2exe
from PIL import GifImagePlugin, PngImagePlugin, JpegImagePlugin, BmpImagePlugin, PpmImagePlugin ###
Image._initialized=2
##from ImageDraw import ImageDraw
from PIL.ImageDraw import ImageDraw
from PIL import ImageFilter


VERSION = '0.2'

large_suits = True

# global vars
out_dir = ''
progress = 0
tk_images = []
# global widgets
name_entry = "test12345"
images_dir_entry = "D:/Bilder/TEST/Spielkarten einzeln" ### None
back_file_entry = None
canvas = None
progress_canvas = None
# options
class Options:
    def init_var(self, var_name, var_class):
        var = var_class()
        self.__dict__[var_name+'_var'] = var
    def __getattr__(self, attr):
        var = self.__dict__[attr+'_var']
        return var.get()
    def __setattr__(self, attr, value):
        var = self.__dict__[attr+'_var']
        var.set(value)
options = Options()
#

emblems_dir = os.path.join(sys.path[0], 'data')
if os.name == 'nt' and os.path.isfile(sys.path[0]):
    emblems_dir = os.path.join(sys.prefix, 'data')
canvas_bg = '#5eab6b'

###images_dir_entry = emblems_dir[:-4] + 'cards'


#
filters = ('NONE', 'BLUR', 'CONTOUR', 'DETAIL', 'EDGE_ENHANCE',
           'EDGE_ENHANCE_MORE', 'EMBOSS', 'FIND_EDGES',
           'SHARPEN', 'SMOOTH', 'SMOOTH_MORE')
resample_filters = ('NEAREST', 'BILINEAR', 'BICUBIC', 'ANTIALIAS')


########################################################################


def mk_mask(x, y, fill):
    img = Image.new('RGBA', (x+1,y))
    draw = ImageDraw(img, img.mode)
    d = 3
    xy = (0,d,
          d,0,
          x-d,0,
          x,d,
          x,y-d,
          x-d,y,
          d,y,
          0,y-d,
          )
    draw.polygon(xy, fill=fill)
    return img


def mk_card(im1, color, suit, rank):
  
    return im1 ### 
    _width, _height = im1.size

    imd = ImageDraw(im1, im1.mode)
    imd.polygon((0,0,_width-1,0,_width-1,_height-1,0,_height-1),
                outline=options.outline_color)

    rim = Image.open(os.path.join(emblems_dir, '%s-%s.png' % (color, rank)))
    sim = Image.open(os.path.join(emblems_dir, 'small-%s.png' % suit))
    ##i = 'cdsh'.index(suit)
    ##sim = Image.open('ace/suits.13.png').crop((0,i*13,13,(i+1)*13))
    w1, h1 = rim.size
    w2, h2 = sim.size

    em_w, em_h = max(w1,w2)+2, h1+h2+3
    ##print em_w, em_h
    xy = (0,0,em_w,em_h)
    imd.rectangle(xy, fill='white', outline=options.outline_color)

    im2 = Image.new('RGBA', (em_w-2,em_h-2), 'white')
    #x, y = int(round((em_w-2-w1)/2.)), 1
    #x, y = int((em_w-2-w1)/2.), 1
    x, y = int((em_w-2-w1)/2.)+1, 1
    #print x, y
    im2.paste(rim, (x, y))
    x, y = int(round((em_w-2-w2)/2.)), h1+2
    im2.paste(sim, (x, y))

    im1.paste(im2, (1,1))

    if options.bottom_emblems:
        xy = (_width-em_w-1,_height-em_h-1,_width-1,_height-1)
        imd.rectangle(xy, fill='white', outline=options.outline_color)
        if options.rotate_bottom_emblems:
            im2 = im2.transpose(Image.ROTATE_180)
            im1.paste(im2, (_width-em_w+1, _height-em_h+1))
        else:
            im1.paste(im2, (_width-em_w, _height-em_h))

    if large_suits:
        sim = Image.open(os.path.join(emblems_dir, 'large-%s.png' % suit))
        w2, h2 = sim.size

    if options.top_right_emblem:
        xy = (_width-w2-4,0,_width-1,h2+3)
        imd.rectangle(xy, fill='white', outline=options.outline_color)
        im1.paste(sim, (_width-w2-2, 2))

    if options.bottom_emblems and options.top_right_emblem:
        xy = (0,_height-h2-4,w2+3,_height-1)
        imd.rectangle(xy, fill='white', outline=options.outline_color)
        if options.rotate_bottom_emblems:
            sim = sim.transpose(Image.ROTATE_180)
            im1.paste(sim, (2, _height-h2-2))
        else:
            im1.paste(sim, (2, _height-h2-2))

    if options.intern_padding:
        im = Image.new('RGBA', (options.width,options.height), options.padding_color)
        im.paste(im1, (options.intern_padding,options.intern_padding))
        im1 = im

    return im1

##     im2 = Image.new('RGBA', (width, height))
##     mask = Image.new('RGBA', (width, height))
##     d = ImageDraw(mask, 'RGBA')
##     dx, dy = 3, 3
##     xy = (0, dy,
##           dx, 0,
##           width-dx-1, 0,
##           width-1, dy,
##           width-1, height-dy,
##           width-dx-1, height,
##           dx, height,
##           0, height-dy)
##     d.polygon(xy, fill='black')
##     ##imd.polygon(xy, outline=options.outline_color)
##     ##mask.show()
##     im = Image.composite(im1,im2,mask)
##     ##im.show()
##     return im


def resize_image(im, _width=None, _height=None, save_aspect=True, filter=None):
    if _width is None:
        _width=options.width
    if _height is None:
        _height=options.height
    resample = {
        'NEAREST'  : Image.NEAREST,
        'BILINEAR' : Image.BILINEAR,
        'BICUBIC'  : Image.BICUBIC,
        'ANTIALIAS': Image.ANTIALIAS,
        } [filter]
    if save_aspect:
        w, h = im.size
        ax, ay = float(w)/_width, float(h)/_height
        if ax > ay:
            ww, hh = int(w/ay), _height
            im = im.resize((ww,hh), resample=resample)
            dx = (ww-_width)/2
            im = im.crop((dx,0,_width+dx,_height))
        else:
            ww, hh = _width, int(h/ax)
            im = im.resize((ww,hh), resample=resample)
            im = im.crop((0,0,_width,_height))
    else:
        im = im.resize((_width,_height), resample=resample)
    return im


def apply_filter(im, filter):
    if filter == 'NONE':
        return im
    f = ImageFilter.__dict__[filter]
    return im.filter(f)


def mk_cardset():
    ls = os.listdir(options.images_dir)
    ls.sort()
    images = []
    n = 0
    for f in ls:
        update_progress()
        fn = os.path.join(options.images_dir, f)
        try:
            im = Image.open(fn).convert('RGBA')
        except IOError, err:
            if os.name == 'posix':
                print 'WARNING: %s: %s' % (fn, err)
            n += 1
            continue
        ##print '+', fn
        im = resize_image(im, options.width-2*options.intern_padding,
                          options.height-2*options.intern_padding,
                          options.save_aspect, options.resample_filter)
        im = apply_filter(im, options.filter)
        images.append(im)
        n += 1
        if n == 52:
            break
    if not images:
        tkMessageBox.showinfo(title='Info',
                              message='Can\'t find an images in the directory:\n'+options.images_dir)
        return False
    n = 0

    for j in range(13):
       for i in range(4):       
            update_progress()
            fn = os.path.join(options.images_dir, ls[n])
            suit = 'cdhs'[i]
            color = suit in 'cs' and 'black' or 'red'
            rank = str(j)
            im = images[n]
            im = mk_card(im, color=color, suit=suit, rank=rank)
            im.save(os.path.join(out_dir, '%02d%s.png' % (int(rank)+1, suit)))
            n += 1
            if n == len(images):
                n = 0
            #print '%02d%s' % (int(rank)+1, suit)
    return True


########################################################################

def mk_shade():
    update_progress()
    img = Image.new('RGBA', (options.width, options.height))
    imd = ImageDraw(img, 'RGBA')
    y = 0
    while y < options.height:
        x = y%2
        while x < options.width:
            imd.point((x, y), '#519ae7')
            x += 2
        y += 1
    img.save(os.path.join(out_dir, 'shade.png'))


########################################################################

def draw_outline(d, color):
    d.polygon((0,0,options.width-1,0,options.width-1,options.height-1,0,options.height-1), outline=color)

##     dd = 5
##     for x0, y0, x1, y1 in (
##         (dd, 0, options.width-1-dd, 0),
##         (options.width-1, dd, options.width-1, options.height-1-dd),
##         (dd, options.height-1, options.width-1-dd, options.height-1),
##         (0, dd, 0, options.height-dd) ):
##         d.line((x0, y0, x1, y1), fill=color, width=1)
##     for x0, y0, x1, y1, start, end in (
##         (0, 0, 2*dd, 2*dd, 180, 270),
##         (options.width-1-2*dd, 0, options.width-1, 2*dd, 270, 360),
##         (options.width-1-2*dd, options.height-1-2*dd, options.width-1, options.height-1, 0, 90),
##         (0, options.height-1-2*dd, 2*dd, options.height-1, 90, 180),
##         ):
##         d.arc((x0, y0, x1, y1), start, end, fill=color)

def mk_bottom():
    update_progress()

    btm = Image.new('RGBA', (options.width, options.height))
    btm_n = Image.new('RGBA', (options.width, options.height))
    d = ImageDraw(btm, 'RGBA')
    draw_outline(d, 'black')
    d_n = ImageDraw(btm_n, 'RGBA')
    draw_outline(d_n, 'white')
    btm.save(os.path.join(out_dir, 'bottom01.png'))
    btm_n.save(os.path.join(out_dir, 'bottom01-n.png'))

##     btm = Image.open('bottom01.png').convert('RGBA')
##     d = ImageDraw(btm, 'RGBA')
##     btm_n = Image.open('bottom01-n.png').convert('RGBA')
##     d_n = ImageDraw(btm_n, 'RGBA')
    ###print("Hello", "how are you?") 

    for i in (
        
        'bottom03',
        'bottom04',
        'bottom05',
        'bottom06',
        'bottom07',
        'l01',
        'l02',
        'l03',
        'l04'):
        update_progress()
        br = Image.open(os.path.join(emblems_dir, i+'.png')).convert('RGBA')
        w, h = br.size
        im = btm.copy()
        im.paste(br, ((options.width-w)/2,(options.height-h)/2))
        im.save(os.path.join(out_dir, i+'.png'))
        br = Image.open(os.path.join(emblems_dir, i+'-n.png')).convert('RGBA')
        w, h = br.size
        im = btm_n.copy()
        im.paste(br, ((options.width-w)/2,(options.height-h)/2))
        im.save(os.path.join(out_dir, i+'-n.png'))

    y = 0
    while y < options.height:
        x = 0+(y%4) #/2
        while x < options.width:
            if (x%8 != 0 or y%8 != 0) and (x%8 != 4 or y%8 != 4) :
                d.point((x, y), 'black')
                d_n.point((x, y), 'white')
            x += 4
        y += 2
    btm.save(os.path.join(out_dir, 'bottom02.png'))
    btm_n.save(os.path.join(out_dir, 'bottom02-n.png'))


########################################################################

card_offset = 20
shadow_offset = 7

def sh_region(im, x, y, w, h):
    ww, hh = im.size
    d = ImageDraw(im, 'RGBA')
    yy = y
    while yy < y+h:
        xx = x+(yy%2)
        while xx < x+w:
            d.point((xx, yy), 'black')
            xx += 2
        yy += 1

def mk_shadow():
    sh = Image.new('RGBA', (options.width, 16))
    sh_region(sh, 0, 16-shadow_offset, options.width, options.height)
    sh_region(sh, options.width-shadow_offset-1, 0, options.width, 16-shadow_offset)
    sh.save(os.path.join(out_dir, 'shadow00.png'))
    for i in range(13):
        update_progress()
        w, h = shadow_offset, options.height-16+i*card_offset
        sh = Image.new('RGBA', (w,h))
        sh_region(sh, 0, 0, w, h)
        sh.save(os.path.join(out_dir, 'shadow%02d.png'%(i+1)))


########################################################################

def mk_back():
    update_progress()
    d = options.back_padding
    im = Image.new('RGBA', (options.width, options.height))
    imd = ImageDraw(im, 'RGBA')
    if d:
        imd.polygon((0,0,options.width-1,0,options.width-1,options.height-1,0,options.height-1), fill=options.back_padding_color, outline=options.back_outline_color)
    im2 = resize_image(Image.open(options.back_file),
                       options.width-2*d, options.height-2*d,
                       options.back_save_aspect,
                       options.back_resample_filter)
    im2 = apply_filter(im2, options.back_filter)
    im.paste(im2, (d,d))
    imd.polygon((d,d,options.width-1-d,d,options.width-1-d,options.height-1-d,d,options.height-1-d), outline=options.back_outline_color)
    im.save(os.path.join(out_dir, 'back01.png'))

########################################################################

def mk_conf():
    fd = open(os.path.join(out_dir, 'config.txt'), 'w')
    print >> fd, '''\
PySol solitaire cardset;4;.png;1;52;7
123-%s;%s
%d %d 8
16 20 7 7
back01.png
back01.png''' % (out_dir, options.name, options.width, options.height)
    open(os.path.join(out_dir, 'COPYRIGHT'), 'a')


########################################################################
# GUI
########################################################################

def update_progress():
    global progress
    progress += 1
    #w, h = progress_canvas.cget('width'), progress_canvas.cget('height')
    w, h = progress_canvas.winfo_width(), progress_canvas.winfo_height()
    #w, h = int(w), int(h)
    ww = w*progress/130
    progress_canvas.create_rectangle(0, 0, ww, h, fill='blue')
    root.update()


def flash_entry(entry):
    entry.focus_force()
    for i in range(6):
        bg = i%2 and 'white' or 'black'
        entry.config(bg=bg)
        root.update()
        root.after(250)


def select_dir(*args):
    dialog = tkFileDialog.Directory(root)
    d = dialog.show()
    if d:
        options.images_dir = os.path.normpath(d)


def select_back(*args):
    dialog = tkFileDialog.Open(root)
    f = dialog.show()
    if f:
        options.back_file = os.path.normpath(f)

def select_color(w, var):
    color = tkColorChooser.Chooser(initialcolor=var.get()).show()
    color = color[1]
    if color:
        color = str(color)
        w.config(bg=color)
        var.set(color)


def create_cardset(*args):
    global out_dir, progress
    if not options.name:
        flash_entry(name_entry)
        return
    if (not options.images_dir or
        not os.path.exists(options.images_dir) or
        not os.path.isdir(options.images_dir)):
        flash_entry(images_dir_entry)
        return
    if (not options.back_file or
        not os.path.exists(options.back_file) or
        not os.path.isfile(options.back_file)):
        flash_entry(back_file_entry)
        return
    dir_name = 'cardset-'+options.name.lower().replace(' ', '-')
    if os.name == 'nt':
        appdata = os.environ.get('APPDATA', os.path.abspath('/'))
        ###out_dir = os.path.join(appdata, 'PySolFC', 'cardsets', dir_name)
        out_dir = dir_name ###
    else:
        out_dir = dir_name
    progress = 0
    progress_canvas.delete('all')
    if os.path.exists(out_dir):
        ret = tkMessageBox.askokcancel(title='Question',
                                       message='Directory\n%s\nalready exists.\nOverwrite?' % out_dir)
        if not ret:
            return
    if not os.path.exists(out_dir): os.makedirs(out_dir)
    root.config(cursor='watch')
    root.update()
    #
    ret = False
    try:
        ret = mk_cardset()
        if ret:
            mk_shade()
            mk_bottom()
            mk_shadow()
            mk_back()
            mk_conf()
    #
    finally:
        root.config(cursor='')
    if ret:
        show_cardset(out_dir)
        progress_canvas.delete('all')
        tkMessageBox.showinfo(title='Info',
                              message='Cardset created in the directory:\n'
                              +os.path.abspath(out_dir))


def show_cardset(dir):
    
    global tk_images
    tk_images = []
    ls = glob(os.path.join(dir, '[0-9][0-9][a-z].png'))
    ls.append(os.path.join(dir, 'back01.png'))
    
    ls.sort()
    pf = None
    x, y = 10, 10
    width, height = 0, 0
    canvas.delete('all')
    for f in ls:
        ###print (f)
        #image = PhotoImage(file=f)
        image = ImageTk.PhotoImage(Image.open(f))
        ###print (f)
        tk_images.append(image)
        ff = os.path.split(f)[1]
        if pf is None:
            pf = ff[:2]
            x, y = 10, 10
        elif ff[:2] != pf:
            pf = ff[:2]
            x = 10
            y += image.height()+10
        else:
            x += image.width()+10
        canvas.create_image(x, y, image=image, anchor=NW)
        ##canvas.create_rectangle(x, y, x+image.width(), y+image.height())
        width = max(width, x)
        height = max(height, y)
    width, height = width+image.width()+10, height+image.height()+10
    canvas.config(scrollregion=(0, 0, width, height))


def create_widgets():
    global canvas, name_entry, images_dir_entry, back_file_entry, progress_canvas
    #
    root = Tk()
    root.wm_geometry("%dx%d+%d+%d" % (1200,800,10,10))###
    
    if os.name == 'posix':
        root.option_add('*font', 'Helvetica 12', 50)
    paned_window = PanedWindow(root)
    paned_window.pack(expand=YES, fill=BOTH)
    #
    left_frame = Frame(paned_window)
    right_frame = Frame(paned_window)
    paned_window.add(left_frame)
    paned_window.add(right_frame)
    #
    frame = LabelFrame(left_frame, text='Main', padx=4, pady=4)
    frame.pack(fill=X, padx=4, pady=4)
    #
    row = 0
    w = Label(frame, text='Cardset name:')
    w.grid(row=row, column=0, sticky=W)
    options.init_var('name', StringVar)
    options.name = name_entry ###'test12345' ###
    name_entry = Entry(frame, textvariable=options.name_var, bg='white')
    name_entry.grid(row=row, column=1, columnspan=4, sticky=EW)
    #
    row += 1
    w = Label(frame, text='Size:')
    w.grid(row=row, column=0, sticky=W)
    #
    from_, to = 90, 200
    options.init_var('width', IntVar)
    options.width = 144  ###70
    w = Spinbox(frame, from_=from_, to=to, bg='white', width=4, textvariable=options.width_var)
    w.grid(row=row, column=1, sticky=EW)
    w.bind('<4>', lambda e, var=options.width_var, max=to: var.get()<max and var.set(var.get()+1))
    w.bind('<5>', lambda e, var=options.width_var, min=from_: var.get()>min and var.set(var.get()-1))
    #
    w = Label(frame, text=' x ')
    w.grid(row=row, column=2)
    #
    from_, to = 100, 220
    options.init_var('height', IntVar)
    options.height = 216  ###100
    w = Spinbox(frame, from_=from_, to=to, bg='white', width=4, textvariable=options.height_var)
    w.grid(row=row, column=3, sticky=EW)
    w.bind('<4>', lambda e, var=options.height_var, max=to: var.get()<max and var.set(var.get()+1))
    w.bind('<5>', lambda e, var=options.height_var, min=from_: var.get()>min and var.set(var.get()-1))
    #
    frame.columnconfigure(4, weight=1)
    frame.rowconfigure(row+1, weight=1)
    #
    frame = LabelFrame(left_frame, text='Face', padx=4, pady=4)
    frame.pack(fill=X, padx=4, pady=4)
    #
    row = 0
    w = Label(frame, text='Directory with images:')
    w.grid(row=row, column=0, sticky=W)
    options.init_var('images_dir', StringVar)
    options.images_dir = images_dir_entry ###"D:/Bilder/TEST/Spielkarten einzeln" ###
    images_dir_entry = Entry(frame, textvariable=options.images_dir_var, bg='white')
    images_dir_entry.grid(row=row, column=1, columnspan=3, sticky=EW)
    w = Button(frame, text='Select ...', command=select_dir)
    w.grid(row=row, column=4, sticky=EW)
    #
    row += 1
    w = Label(frame, text='Padding:')
    w.grid(row=row, column=0, sticky=W)
    from_, to = 0, 20
    options.init_var('intern_padding', IntVar)
    options.intern_padding = 0 ###1
    w = Spinbox(frame, from_=from_, to=to, bg='white', width=4, textvariable=options.intern_padding_var)
    w.grid(row=row, column=1, sticky=EW)
    w.bind('<4>', lambda e, var=options.intern_padding_var, max=to: var.get()<max and var.set(var.get()+1))
    w.bind('<5>', lambda e, var=options.intern_padding_var, min=from_: var.get()>min and var.set(var.get()-1))
    #
    row += 1
    options.init_var('padding_color', StringVar)
    options.padding_color = 'white'
    w = Label(frame, text='Padding color:')
    w.grid(row=row, column=0, sticky=W)
    w = Label(frame, bg=options.padding_color, textvariable=options.padding_color_var)
    w.grid(row=row, column=1, columnspan=3, sticky=EW)
    w = Button(frame, text='Select ...', command=lambda w=w, var=options.padding_color_var: select_color(w, var))
    w.grid(row=row, column=4, sticky=EW)
    #
    row += 1
    options.init_var('outline_color', StringVar)
    options.outline_color = 'black'
    w = Label(frame, text='Outline color:')
    w.grid(row=row, column=0, sticky=W)
    w = Label(frame, bg=options.outline_color, textvariable=options.outline_color_var)
    w.grid(row=row, column=1, columnspan=3, sticky=EW)
    w = Button(frame, text='Select ...', command=lambda w=w, var=options.outline_color_var: select_color(w, var))
    w.grid(row=row, column=4, sticky=EW)
    #
    row += 1
    options.init_var('resample_filter', StringVar)
    options.resample_filter = 'ANTIALIAS'
    w = Label(frame, text='Resize:')
    w.grid(row=row, column=0, sticky=W)
    w = OptionMenu(frame, options.resample_filter_var, *resample_filters)
    w.grid(row=row, column=1, columnspan=4, sticky=EW)
    #
    row += 1
    options.init_var('filter', StringVar)
    options.filter = 'NONE'
    w = Label(frame, text='Filter:')
    w.grid(row=row, column=0, sticky=W)
    w = OptionMenu(frame, options.filter_var, *filters)
    w.grid(row=row, column=1, columnspan=4, sticky=EW)
    #
    row += 1
    options.init_var('save_aspect', BooleanVar)
    options.save_aspect = False ###True
    w = Checkbutton(frame, text='Save aspect', variable=options.save_aspect_var, anchor=W)
    w.grid(column=0, row=row, columnspan=6, sticky=EW)
    #
    row += 1
    options.init_var('top_right_emblem', BooleanVar)
    options.top_right_emblem = False ###True
    w = Checkbutton(frame, text='Top-right emblem', variable=options.top_right_emblem_var, anchor=W)
    w.grid(column=0, row=row, columnspan=6, sticky=EW)
    #
    row += 1
    options.init_var('bottom_emblems', BooleanVar)
    options.bottom_emblems = False
    w = Checkbutton(frame, text='Bottom emblems', variable=options.bottom_emblems_var, anchor=W)
    w.grid(column=0, row=row, columnspan=6, sticky=EW)
    #
    row += 1
    options.init_var('rotate_bottom_emblems', BooleanVar)
    options.rotate_bottom_emblems = False ###True
    w = Checkbutton(frame, text='Rotate bottom emblems', variable=options.rotate_bottom_emblems_var, anchor=W)
    w.grid(column=0, row=row, columnspan=6, sticky=EW)
    #
    frame.columnconfigure(0, weight=1)
    frame.rowconfigure(row+1, weight=1)
    #
    frame = LabelFrame(left_frame, text='Back', padx=4, pady=4)
    frame.pack(fill=X, padx=4, pady=4)
    #
    row = 0
    w = Label(frame, text='Image:')
    w.grid(row=row, column=0, sticky=W)
    options.init_var('back_file', StringVar)
    options.back_file = os.path.join(emblems_dir, 'back.jpg')
    back_file_entry = Entry(frame, textvariable=options.back_file_var, bg='white')
    back_file_entry.grid(row=row, column=1, columnspan=3, sticky=EW)
    w = Button(frame, text='Select ...', command=select_back)
    w.grid(row=row, column=4, sticky=EW)
    #
    row += 1
    w = Label(frame, text='Padding:')
    w.grid(row=row, column=0, sticky=W)
    from_, to = 0, 20
    options.init_var('back_padding', IntVar)
    options.back_padding = 0 ###4
    w = Spinbox(frame, from_=from_, to=to, bg='white', width=4, textvariable=options.back_padding_var)
    w.grid(row=row, column=1, sticky=EW)
    w.bind('<4>', lambda e, var=options.back_padding_var, max=to: var.get()<max and var.set(var.get()+1))
    w.bind('<5>', lambda e, var=options.back_padding_var, min=from_: var.get()>min and var.set(var.get()-1))
    #
    row += 1
    options.init_var('back_padding_color', StringVar)
    options.back_padding_color = 'white'
    w = Label(frame, text='Padding color:')
    w.grid(row=row, column=0, sticky=W)
    w = Label(frame, bg=options.back_padding_color, textvariable=options.back_padding_color_var)
    w.grid(row=row, column=1, columnspan=3, sticky=EW)
    w = Button(frame, text='Select ...', command=lambda w=w, var=options.back_padding_color_var: select_color(w, var))
    w.grid(row=row, column=4, sticky=EW)
    #
    row += 1
    options.init_var('back_outline_color', StringVar)
    options.back_outline_color = 'black'
    w = Label(frame, text='Outline color:')
    w.grid(row=row, column=0, sticky=W)
    w = Label(frame, bg=options.back_outline_color, textvariable=options.back_outline_color_var)
    w.grid(row=row, column=1, columnspan=3, sticky=EW)
    w = Button(frame, text='Select ...', command=lambda w=w, var=options.back_outline_color_var: select_color(w, var))
    w.grid(row=row, column=4, sticky=EW)
    #
    row += 1
    options.init_var('back_resample_filter', StringVar)
    options.back_resample_filter = 'ANTIALIAS'
    w = Label(frame, text='Resize:')
    w.grid(row=row, column=0, sticky=W)
    w = OptionMenu(frame, options.back_resample_filter_var, *resample_filters)
    w.grid(row=row, column=1, columnspan=4, sticky=EW)
    #
    row += 1
    options.init_var('back_filter', StringVar)
    options.back_filter = 'NONE'
    w = Label(frame, text='Filter:')
    w.grid(row=row, column=0, sticky=W)
    w = OptionMenu(frame, options.back_filter_var, *filters)
    w.grid(row=row, column=1, columnspan=4, sticky=EW)
    #
    row += 1
    options.init_var('back_save_aspect', BooleanVar)
    options.back_save_aspect = True
    w = Checkbutton(frame, text='Save aspect', variable=options.back_save_aspect_var, anchor=W)
    w.grid(column=0, row=row, columnspan=6, sticky=EW)
    #
    frame.columnconfigure(0, weight=1)
    frame.rowconfigure(row+1, weight=1)
    #
    canvas = Canvas(right_frame, bg=canvas_bg)
    canvas.grid(row=0, column=0, sticky=NSEW)
    canvas.bind('<4>', lambda e: canvas.yview_scroll(-5, 'unit'))
    canvas.bind('<5>', lambda e: canvas.yview_scroll(5, 'unit'))
    #
    sb = Scrollbar(right_frame)
    sb.grid(row=0, column=1, sticky=NS)
    canvas.config(yscrollcommand=sb.set)
    sb.config(command=canvas.yview)
    #
    sb = Scrollbar(right_frame, orient=HORIZONTAL)
    sb.grid(row=1, column=0, sticky=EW)
    canvas.config(xscrollcommand=sb.set)
    sb.config(command=canvas.xview)
    #
    right_frame.columnconfigure(0, weight=1)
    right_frame.rowconfigure(0, weight=1)
    #
    Frame(root, relief=SUNKEN, height=2, bd=1).pack(fill=X)
    b_frame = Frame(root)
    b_frame.pack(fill=X)
    button = Button(b_frame, text='Create', command=create_cardset, width=8)
    button.pack(side=LEFT, padx=5, pady=5)
    f = Frame(b_frame, relief=SUNKEN, bd=2)
    f.pack(side=LEFT, fill=BOTH, expand=YES, pady=10)
    progress_canvas = Canvas(f, height=10)
    progress_canvas.pack(fill=BOTH, expand=YES)
    button = Button(b_frame, text='Quit', command=root.quit, width=8)
    button.pack(side=RIGHT, padx=5, pady=5)
    #
    root.title('Cardset Maker v0.2') ###
    return root


########################################################################

if __name__ == '__main__':
    root = create_widgets()
    root.mainloop()


